# coding: utf-8

"""
    Infrahub-API

    Leverage the Infrahub API and Hyperstack platform to easily create, manage, and scale powerful GPU virtual machines and their associated resources.   Access this SDK to automate the deployment of your workloads and streamline your infrastructure management.  To contribute, please raise an issue with a bug report, feature request, feedback, or general inquiry.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ..models.instance_flavor_fields import InstanceFlavorFields
from typing import Optional, Set
from typing_extensions import Self

class ClusterFields(BaseModel):
    """
    ClusterFields
    """ # noqa: E501
    api_address: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    environment_name: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    keypair_name: Optional[StrictStr] = None
    kube_config: Optional[StrictStr] = None
    kubernetes_version: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    node_count: Optional[StrictInt] = None
    node_flavor: Optional[InstanceFlavorFields] = None
    status: Optional[StrictStr] = None
    status_reason: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["api_address", "created_at", "environment_name", "id", "keypair_name", "kube_config", "kubernetes_version", "name", "node_count", "node_flavor", "status", "status_reason"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ClusterFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of node_flavor
        if self.node_flavor:
            _dict['node_flavor'] = self.node_flavor.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ClusterFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api_address": obj.get("api_address"),
            "created_at": obj.get("created_at"),
            "environment_name": obj.get("environment_name"),
            "id": obj.get("id"),
            "keypair_name": obj.get("keypair_name"),
            "kube_config": obj.get("kube_config"),
            "kubernetes_version": obj.get("kubernetes_version"),
            "name": obj.get("name"),
            "node_count": obj.get("node_count"),
            "node_flavor": InstanceFlavorFields.from_dict(obj["node_flavor"]) if obj.get("node_flavor") is not None else None,
            "status": obj.get("status"),
            "status_reason": obj.get("status_reason")
        })
        return _obj


