# coding: utf-8

"""
    Infrahub-API

    Leverage the Infrahub API and Hyperstack platform to easily create, manage, and scale powerful GPU virtual machines and their associated resources.   Access this SDK to automate the deployment of your workloads and streamline your infrastructure management.  To contribute, please raise an issue with a bug report, feature request, feedback, or general inquiry.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ..models.allocated_gpu_count_graph import AllocatedGPUCountGraph
from typing import Optional, Set
from typing_extensions import Self

class Contract(BaseModel):
    """
    Contract
    """ # noqa: E501
    allocated_gpu_count_graph: Optional[List[AllocatedGPUCountGraph]] = None
    granularity: Optional[StrictInt] = None
    id: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = None
    status: Optional[StrictStr] = None
    total_gpu_allocation: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["allocated_gpu_count_graph", "granularity", "id", "org_id", "status", "total_gpu_allocation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Contract from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in allocated_gpu_count_graph (list)
        _items = []
        if self.allocated_gpu_count_graph:
            for _item_allocated_gpu_count_graph in self.allocated_gpu_count_graph:
                if _item_allocated_gpu_count_graph:
                    _items.append(_item_allocated_gpu_count_graph.to_dict())
            _dict['allocated_gpu_count_graph'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Contract from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "allocated_gpu_count_graph": [AllocatedGPUCountGraph.from_dict(_item) for _item in obj["allocated_gpu_count_graph"]] if obj.get("allocated_gpu_count_graph") is not None else None,
            "granularity": obj.get("granularity"),
            "id": obj.get("id"),
            "org_id": obj.get("org_id"),
            "status": obj.get("status"),
            "total_gpu_allocation": obj.get("total_gpu_allocation")
        })
        return _obj


