# coding: utf-8

"""
    Infrahub-API

    Leverage the Infrahub API and Hyperstack platform to easily create, manage, and scale powerful GPU virtual machines and their associated resources.   Access this SDK to automate the deployment of your workloads and streamline your infrastructure management.  To contribute, please raise an issue with a bug report, feature request, feedback, or general inquiry.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ..models.contract_discount_plan_fields import ContractDiscountPlanFields
from typing import Optional, Set
from typing_extensions import Self

class CustomerContractFields(BaseModel):
    """
    CustomerContractFields
    """ # noqa: E501
    created_at: Optional[datetime] = None
    description: Optional[StrictStr] = None
    discounts: Optional[List[ContractDiscountPlanFields]] = None
    end_date: Optional[datetime] = None
    expiration_policy: Optional[StrictInt] = None
    id: Optional[StrictInt] = None
    org_id: Optional[StrictInt] = None
    start_date: Optional[datetime] = None
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["created_at", "description", "discounts", "end_date", "expiration_policy", "id", "org_id", "start_date", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomerContractFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in discounts (list)
        _items = []
        if self.discounts:
            for _item_discounts in self.discounts:
                if _item_discounts:
                    _items.append(_item_discounts.to_dict())
            _dict['discounts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomerContractFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "description": obj.get("description"),
            "discounts": [ContractDiscountPlanFields.from_dict(_item) for _item in obj["discounts"]] if obj.get("discounts") is not None else None,
            "end_date": obj.get("end_date"),
            "expiration_policy": obj.get("expiration_policy"),
            "id": obj.get("id"),
            "org_id": obj.get("org_id"),
            "start_date": obj.get("start_date"),
            "status": obj.get("status")
        })
        return _obj


