# coding: utf-8

"""
    Infrahub-API

    Leverage the Infrahub API and Hyperstack platform to easily create, manage, and scale powerful GPU virtual machines and their associated resources.   Access this SDK to automate the deployment of your workloads and streamline your infrastructure management.  To contribute, please raise an issue with a bug report, feature request, feedback, or general inquiry.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ..models.discount_plan_fields import DiscountPlanFields
from typing import Optional, Set
from typing_extensions import Self

class GetEntityDiscountDetailResponse(BaseModel):
    """
    GetEntityDiscountDetailResponse
    """ # noqa: E501
    message: Optional[StrictStr] = None
    organization: Optional[List[DiscountPlanFields]] = None
    status: Optional[StrictBool] = None
    virtual_machine: Optional[List[DiscountPlanFields]] = Field(default=None, alias="virtual-machine")
    __properties: ClassVar[List[str]] = ["message", "organization", "status", "virtual-machine"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetEntityDiscountDetailResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in organization (list)
        _items = []
        if self.organization:
            for _item_organization in self.organization:
                if _item_organization:
                    _items.append(_item_organization.to_dict())
            _dict['organization'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in virtual_machine (list)
        _items = []
        if self.virtual_machine:
            for _item_virtual_machine in self.virtual_machine:
                if _item_virtual_machine:
                    _items.append(_item_virtual_machine.to_dict())
            _dict['virtual-machine'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetEntityDiscountDetailResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "message": obj.get("message"),
            "organization": [DiscountPlanFields.from_dict(_item) for _item in obj["organization"]] if obj.get("organization") is not None else None,
            "status": obj.get("status"),
            "virtual-machine": [DiscountPlanFields.from_dict(_item) for _item in obj["virtual-machine"]] if obj.get("virtual-machine") is not None else None
        })
        return _obj


