# coding: utf-8

"""
    Infrahub-API

    Leverage the Infrahub API and Hyperstack platform to easily create, manage, and scale powerful GPU virtual machines and their associated resources.   Access this SDK to automate the deployment of your workloads and streamline your infrastructure management.  To contribute, please raise an issue with a bug report, feature request, feedback, or general inquiry.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ..models.contract_resource_payload import ContractResourcePayload
from typing import Optional, Set
from typing_extensions import Self

class CreateContractPayload(BaseModel):
    """
    CreateContractPayload
    """ # noqa: E501
    description: Optional[StrictStr] = None
    discount_resources: List[ContractResourcePayload]
    end_date: Optional[datetime] = None
    expiration_policy: StrictInt
    org_id: StrictInt
    start_date: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["description", "discount_resources", "end_date", "expiration_policy", "org_id", "start_date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateContractPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in discount_resources (list)
        _items = []
        if self.discount_resources:
            for _item_discount_resources in self.discount_resources:
                if _item_discount_resources:
                    _items.append(_item_discount_resources.to_dict())
            _dict['discount_resources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateContractPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "discount_resources": [ContractResourcePayload.from_dict(_item) for _item in obj["discount_resources"]] if obj.get("discount_resources") is not None else None,
            "end_date": obj.get("end_date"),
            "expiration_policy": obj.get("expiration_policy"),
            "org_id": obj.get("org_id"),
            "start_date": obj.get("start_date")
        })
        return _obj


